<?php
class ControllerExtensionPaymentParspal extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/parspal');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_parspal', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');

		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_apiKey'] = $this->language->get('entry_apiKey');
		$data['entry_debug'] = $this->language->get('entry_debug');
		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_canceled_reversal_status'] = $this->language->get('entry_canceled_reversal_status');
		$data['entry_completed_status'] = $this->language->get('entry_completed_status');
		$data['entry_failed_status'] = $this->language->get('entry_failed_status');
		$data['entry_pending_status'] = $this->language->get('entry_pending_status');
		$data['entry_processed_status'] = $this->language->get('entry_processed_status');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['help_debug'] = $this->language->get('help_debug');
		$data['help_total'] = $this->language->get('help_total');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');
		$data['tab_order_status'] = $this->language->get('tab_order_status');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['title'])) {
			$data['error_title'] = $this->error['title'];
		} else {
			$data['error_title'] = '';
		}
		if (isset($this->error['apiKey'])) {
			$data['error_apiKey'] = $this->error['apiKey'];
		} else {
			$data['error_apiKey'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/parspal', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/parspal', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_parspal_title'])) {
			$data['payment_parspal_title'] = $this->request->post['payment_parspal_title'];
		} else {
			$data['payment_parspal_title'] = $this->config->get('payment_parspal_title');
		}
		if (isset($this->request->post['payment_parspal_apiKey'])) {
			$data['payment_parspal_apiKey'] = $this->request->post['payment_parspal_apiKey'];
		} else {
			$data['payment_parspal_apiKey'] = $this->config->get('payment_parspal_apiKey');
		}

		if (isset($this->request->post['payment_parspal_debug'])) {
			$data['payment_parspal_debug'] = $this->request->post['payment_parspal_debug'];
		} else {
			$data['payment_parspal_debug'] = $this->config->get('payment_parspal_debug');
		}

		if (isset($this->request->post['payment_parspal_total'])) {
			$data['payment_parspal_total'] = $this->request->post['payment_parspal_total'];
		} else {
			$data['payment_parspal_total'] = $this->config->get('payment_parspal_total');
		}

		if (isset($this->request->post['payment_parspal_canceled_reversal_status_id'])) {
			$data['payment_parspal_canceled_reversal_status_id'] = $this->request->post['payment_parspal_canceled_reversal_status_id'];
		} else {
			$data['payment_parspal_canceled_reversal_status_id'] = $this->config->get('payment_parspal_canceled_reversal_status_id');
		}

		if (isset($this->request->post['payment_parspal_completed_status_id'])) {
			$data['payment_parspal_completed_status_id'] = $this->request->post['payment_parspal_completed_status_id'];
		} else {
			$data['payment_parspal_completed_status_id'] = $this->config->get('payment_parspal_completed_status_id');
		}

		if (isset($this->request->post['payment_parspal_failed_status_id'])) {
			$data['payment_parspal_failed_status_id'] = $this->request->post['payment_parspal_failed_status_id'];
		} else {
			$data['payment_parspal_failed_status_id'] = $this->config->get('payment_parspal_failed_status_id');
		}

		if (isset($this->request->post['payment_parspal_pending_status_id'])) {
			$data['payment_parspal_pending_status_id'] = $this->request->post['payment_parspal_pending_status_id'];
		} else {
			$data['payment_parspal_pending_status_id'] = $this->config->get('payment_parspal_pending_status_id');
		}

		if (isset($this->request->post['payment_parspal_processed_status_id'])) {
			$data['payment_parspal_processed_status_id'] = $this->request->post['payment_parspal_processed_status_id'];
		} else {
			$data['payment_parspal_processed_status_id'] = $this->config->get('payment_parspal_processed_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_parspal_geo_zone_id'])) {
			$data['payment_parspal_geo_zone_id'] = $this->request->post['payment_parspal_geo_zone_id'];
		} else {
			$data['payment_parspal_geo_zone_id'] = $this->config->get('payment_parspal_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_parspal_status'])) {
			$data['payment_parspal_status'] = $this->request->post['payment_parspal_status'];
		} else {
			$data['payment_parspal_status'] = $this->config->get('payment_parspal_status');
		}

		if (isset($this->request->post['payment_parspal_sort_order'])) {
			$data['payment_parspal_sort_order'] = $this->request->post['payment_parspal_sort_order'];
		} else {
			$data['payment_parspal_sort_order'] = $this->config->get('payment_parspal_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/parspal', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/parspal')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_parspal_title']) {
			$this->error['title'] = $this->language->get('error_title');
		}
		if (!$this->request->post['payment_parspal_apiKey']) {
			$this->error['apiKey'] = $this->language->get('error_apiKey');
		}

		return !$this->error;
	}
}