<?php

class ControllerExtensionPaymentParspal extends Controller
{
	public function index()
	{
		$this->load->language('extension/payment/parspal');
		$this->load->model('checkout/order');
		$this->load->library('parspal_payment_helper');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		if ($order_info)
		{
			$total = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$p = new Parspal_Payment_Helper($this->config->get('payment_parspal_apiKey'));
			$r = $p->paymentRequest(array(
					'amount'      => intval(ceil($total)),
					'order_id'    => $this->session->data['order_id'],
					'reserve_id'  => @$order_info['order_id'],
					'description' => 'OC-Order#'.$this->session->data['order_id'],
					'return_url'  => $this->url->link('extension/payment/parspal/callback', '', true),
					'payer'       => array(
					'name'        => @$order_info['payment_firstname'].' '.@$order_info['payment_lastname'],
					'email'       => @$order_info['email'],
					'mobile'      => @$order_info['telephone'],
				)));
			if ($r)
			{
				$data['button_confirm'] = $this->language->get('button_confirm');
				$data['Payment_URL'] = $p->gatewayUrl;
				return $this->load->view('extension/payment/parspal', $data);
			}
			else
			{
				return ('Error : ' . $p->error);
			}
		}
	}

	public function callback()
	{
		$this->load->model('checkout/order');
		$order_id = $this->session->data['order_id'];
		$this->load->library('parspal_payment_helper');
		$order_info = $this->model_checkout_order->getOrder($order_id);
		if ($order_info)
		{
			$ok = false;
			$order_status_id = $this->config->get('config_order_status_id');
			$total = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$p = new Parspal_Payment_Helper($this->config->get('payment_parspal_apiKey'));
			$r = $p->paymentVerify($_POST, intval(ceil($total)));
			if ($this->config->get('payment_parspal_debug'))
			{
				$this->log->write('parspal payment :: order_id : ' . $order_id.' :: data : ' . print_r(array('post'=>$_POST,'paypal'=>$p,'price'=>$total,'status'=>$r),1));
			}
			if ($r)
			{
				$ok = true;
				$order_status_id = $this->config->get('payment_parspal_completed_status_id');
				$message = "Payment Completed. OrderId : {$order_id} . PaymentRefrenceId : {$p->txn_id}";
			}
			else
			{
				$message = $p->error;
				$order_status_id = $this->config->get('payment_parspal_failed_status_id');
			}
			$this->model_checkout_order->addOrderHistory($order_id, $order_status_id, $message, $ok);
			if ($ok == true)
			{
				header('location: '.$this->url->link('checkout/success'));
			}
			else
			{
				header('location: '.$this->url->link('checkout/checkout', '', true));
			}
		}
	}
}